#include <DS3231.h>           // This library ensures easy communication with the RTC module
#include <FastLED.h>          // This library makes driving the LEDs a lot easier

#define BUTTON_PIN1 12        // pin on which first pin of button is connected
#define BUTTON_PIN2 13        // pin on which second pin of button is connected
#define LED_PIN     5         // pin on which the data inout of the first LED is connected
#define NUM_LEDS    135       // Number of LEDs in our entire system
#define LED_TYPE    WS2811    //
#define COLOR_ORDER RGB       // order in which we give the input to the LEDs
CRGB leds[NUM_LEDS];          //Telling the library how many RGB LEDs do we have

#define BUTTONLEDPIN1 11
#define BUTTONLEDPIN2 10

int red_intensity = 0;      //Change the value to change the component of red in displaying the digits
int green_intensity = 0;    //Change the value to change the component of green in displaying the digits
int blue_intensity = 255;     //Change the value to change the component of blue in displaying the digits
int startIndex=0;
int state_of_display = 0;     //Variable to set the mode of the display
int colorIndex = 1;           //Required for animations
int increment =0;                     //Required for animations
int mode =1;                     //Required for animations
char timee[9];                //The time given from the RTC module will be stored in this string

CRGBPalette16 currentPalette;   //required code for the animations
TBlendType    currentBlending;  //required code for the animations

extern CRGBPalette16 myRedWhiteBluePalette;  //required code for the animations
extern const TProgmemPalette16 myRedWhiteBluePalette_p PROGMEM;  //required code for the animations

DS3231  rtc(SDA, SCL);    //Defining where the RTC module is connected. Same as A4,A5

 
void setup() {

  
  pinMode(BUTTON_PIN1,INPUT_PULLUP);    //Defining one pin of the button to be the input
  pinMode(BUTTON_PIN2,OUTPUT);          //Defining the second in to be an output
  digitalWrite(BUTTON_PIN2,LOW);        //Defining the second in to be a current sink
   
  rtc.begin();  //Beginning communications with the RTC module

  pinMode(BUTTONLEDPIN1,OUTPUT);    //Defining one pin of the button to be the input
  pinMode(BUTTONLEDPIN2,OUTPUT);          //Defining the second in to be an output

  digitalWrite(BUTTONLEDPIN1,LOW); //Defining one of the button pin to be low so when the button connects the two the other pin goes low
    
  FastLED.addLeds<LED_TYPE, LED_PIN, COLOR_ORDER>(leds, NUM_LEDS).setCorrection( TypicalLEDStrip );   //Initialising the LED library

    Serial.begin(9600);
  currentPalette = RainbowColors_p;  //Just some presets for the animations
  currentBlending = LINEARBLEND;     //Just some presets for the animations

    
//Uncomment the following functon to set the time(Set following parameter according to when you are uploading the code) 
//Once the time is set, you can comment this back up and re-upload the code
//  rtc.setTime(21,36, 20);     // Set the time to 22:00:00 (24hr format)

 

}

void loop() {

//This statement just increments the state_of_display variable whenever button is pressed, which indeed changes the mode of the display
  if(digitalRead(BUTTON_PIN1)==0){
    state_of_display++;
    if(state_of_display>8)state_of_display=0;
    delay(500);
    }
    

  cleardisplay();//This is used to clear the display(with which we can draw on the display once again)
  
  strcpy(timee,rtc.getTimeStr());   //This copies the time from the RTC module and pastes it into our string known as timee
  
  int second_digit_of_minutes = timee[4]-48;    //Since the time is inside a string we assign each digit to a variable while converting the character to an integer 
  int first_digit_of_minutes = timee[3]-48;     //Since the time is inside a string we assign each digit to a variable while converting the character to an integer 
  int second_digit_of_hours = timee[1]-48;     //Since the time is inside a string we assign each digit to a variable while converting the character to an integer 
  int first_digit_of_hours = timee[0]-48;      //Since the time is inside a string we assign each digit to a variable while converting the character to an integer 
  int colon_state = timee[7]%2;                //Sets a variable to 0 or 1 if the colon should be off or on respectively 


//if it is in the first mode it will show time with rainbow effect in the background
  if(state_of_display==0){
    digitalWrite(BUTTONLEDPIN2,HIGH); // this will turn on the light inside the pushbutton
red_intensity = 150;    //set at what intensity red should be of the digits
green_intensity = 150;  //set at what intensity green should be of the digits
blue_intensity = 150; //set at what intensity blue should be of the digits
    startIndex++;// needed code for the rainbow animation behind
    if(startIndex==255)startIndex=0;// needed code for the rainbow animation behind
     colorIndex=startIndex; // needed code for the rainbow animation behind

//code for the rainbowanimation behind
      for( int i = 0; i < NUM_LEDS; i++) {
        leds[i] = ColorFromPalette( RainbowColors_p, colorIndex,50, LINEARBLEND); // change the third value inside the function to change the brightness of the rainbow effect
        colorIndex += 3;
        }
//end of the code for the rainbow animation behind
 
    
    firstdigit(second_digit_of_minutes); //set the second_digit_of_minutes
    seconddigit(first_digit_of_minutes); //set the first_digit_of_minutes
    thirddigit(second_digit_of_hours);   //set the second_digit_of_hours
    fourthdigit(first_digit_of_hours);   //set the first_digit_of_hours
    colon(colon_state);                  //set if the colon should be on or off
     }
//end of the first mode's code


//start of the code for the second mode
  else if(state_of_display==1){


    increment++;                 //necessary coe for the colour transition
    if(increment==255){increment=0;mode++;};//necessary coe for the colour transition
    if(mode==4)mode=1;         //necessary coe for the colour transition


//this will transition the digit color from hot pink  to yellow
    if(mode==1){
    red_intensity=255;
    green_intensity=increment;
    blue_intensity=255-increment;
    }
    // end of the code of the transition


//this will transition the digit color from yellow to cyan
    else if(mode==2){
    red_intensity=255-increment;
    green_intensity=255;
    blue_intensity=increment;}
    // end of the code of the transition
       
//this will transition the digit color from cyan to hot pink
    else if(mode==3){
    red_intensity=increment;
    green_intensity=255-increment;
    blue_intensity=255;
    }
// end of the code of the transition

   

       
    firstdigit(second_digit_of_minutes); //set the second_digit_of_minutes
    seconddigit(first_digit_of_minutes); //set the first_digit_of_minutes
    thirddigit(second_digit_of_hours);   //set the second_digit_of_hours
    fourthdigit(first_digit_of_hours);   //set the first_digit_of_hours
    colon(colon_state);                  //set if the colon should be on or off
  }
//end of the code for the second mode



    if(state_of_display==2){ 
    startIndex++; //necessary code for the animation
    if(startIndex==255)//necessary code for the animation
    startIndex=0;//necessary code for the animation
     colorIndex=startIndex;//necessary code for the animation
     for( int i = 0; i < NUM_LEDS; i++) {
        leds[i] = ColorFromPalette( RainbowColors_p, colorIndex,255,LINEARBLEND); //change the third value to change the brightness of the display in this mode
        colorIndex += 3;
        }
    }
  //end of the code for the third mode



    

   else if(state_of_display==3){
    startIndex++;  //necessary code for the animation
    if(startIndex==255)startIndex=0;  //necessary code for the animation
     colorIndex=startIndex;   //necessary code for the animation
     for( int i = 0; i < NUM_LEDS; i++) {
        leds[i] = ColorFromPalette( RainbowStripeColors_p, colorIndex,255,NOBLEND);//change the third value to change the brightness of the display in this mode
        colorIndex += 3;
        }
    }
    //end of the code for the fourth mode



   else if(state_of_display==4){ 
    startIndex++;//necessary code for the animation
    if(startIndex==255)startIndex=0;//necessary code for the animation
     colorIndex=startIndex;//necessary code for the animation
     for( int i = 0; i < NUM_LEDS; i++) {
        leds[i] = ColorFromPalette( CloudColors_p, colorIndex,255,LINEARBLEND);//change the third value to change the brightness of the display in this mode
        colorIndex += 3;
        }
    }
//end of the code for the fifth mode



   else if(state_of_display==5){ 
    startIndex++;//necessary code for the animation
    if(startIndex==255)//necessary code for the animation
    startIndex=0;//necessary code for the animation
     colorIndex=startIndex;//necessary code for the animation
     for( int i = 0; i < NUM_LEDS; i++) {
        leds[i] = ColorFromPalette( PartyColors_p, colorIndex,255,LINEARBLEND);//change the third value to change the brightness of the display in this mode
        colorIndex += 3;
        }
    }
//end of the code for the sixth mode

    
   else if(state_of_display==6){ 
 //you dont need to worry about all this below as it is just setting up how the display sould light up
    CRGB purple = CHSV( HUE_PURPLE, 255, 255);
    CRGB green  = CHSV( HUE_GREEN, 255, 255);
    CRGB black  = CRGB::Black;
    
    currentPalette = CRGBPalette16(
                                   green,  green,  black,  black,
                                   purple, purple, black,  black,
                                   green,  green,  black,  black,
                                   purple, purple, black,  black );
    startIndex++;//necessary code for the animation
    if(startIndex==255)//necessary code for the animation
    startIndex=0;//necessary code for the animation
     colorIndex=startIndex;//necessary code for the animation
     for( int i = 0; i < NUM_LEDS; i++) {
  leds[i] = ColorFromPalette( currentPalette, colorIndex,255,NOBLEND);//change the third value to change the brightness of the display in this mode
        colorIndex += 3;
        }
    }
//end of the code for the seventh mode

   

     else if(state_of_display==7){ 
      //you dont need to worry about all this below as it is just setting up how the display sould light up
      fill_solid( currentPalette, 16, CRGB::Black);
    // and set every fourth one to white.
    currentPalette[0] = CRGB::White;
    currentPalette[4] = CRGB::White;
    currentPalette[8] = CRGB::White;
    currentPalette[12] = CRGB::White;

    
    startIndex++;//necessary code for the animation
    if(startIndex==255)//necessary code for the animation
    startIndex=0;//necessary code for the animation
     colorIndex=startIndex;//necessary code for the animation
     for( int i = 0; i < NUM_LEDS; i++) {
        leds[i] = ColorFromPalette( currentPalette, colorIndex,255,LINEARBLEND);//change the third value to change the brightness of the display in this mode
        colorIndex += 3;
        }
    }
    //end of the code for the eigth mode


    else if(state_of_display==8){
    cleardisplay(); //this wil continously clear the display so nothing is shown on the display
    digitalWrite(BUTTONLEDPIN2,LOW); //this will tun off the light inside the button, if you dont want it to turn off, comment this function
    }
//end of the code for the ninth mode

    
 FastLED.show();  // in al the above functions we were just giving the LEDs the data, this function tells the LEDs to show all the colors which were declared by the above functions


delay(10);  // delay to set the speed of the animations you could change it to your liking
   

}



//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
//From this point onwards there is nothing to change, UNTIL and unless you want to change the appeaarance of the digits, you dont need to go beow this :)
//-------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
void firstdigit(int first_digit){
  if(first_digit==0){
    leds[34] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[35] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[36] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[38] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[40] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[73] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[74] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[75] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[80] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[82] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[112] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[113] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[114] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

    else if(first_digit==1){
    leds[35] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[39] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[40] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[74] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[81] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[112] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[113] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[114] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     else if(first_digit==2){
    leds[34] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[35] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[36] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[38] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[40] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[73] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[74] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[75] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[80] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[82] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[112] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[113] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[114] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

    else if(first_digit==3){
    leds[34] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[35] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[36] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[38] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[40] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[73] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[74] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[75] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[80] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[82] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[112] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[113] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[114] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

    else if(first_digit==4){
    leds[34] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[35] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[36] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[38] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[40] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[73] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[74] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[75] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[80] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[82] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[112] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[113] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[114] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

    else if(first_digit==5){
    leds[34] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[35] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[36] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[38] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[40] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[73] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[74] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[75] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[80] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[82] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[112] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[113] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[114] = CRGB(red_intensity,green_intensity,blue_intensity);
    }


  else if(first_digit==6){
    leds[34] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[35] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[36] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[38] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[40] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[73] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[74] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[75] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[80] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[82] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[112] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[113] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[114] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     else if(first_digit==7){
    leds[34] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[35] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[36] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[38] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[40] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[73] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[74] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[75] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[80] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[82] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[112] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[113] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[114] = CRGB(red_intensity,green_intensity,blue_intensity);
    }


      else if(first_digit==8){
    leds[34] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[35] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[36] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[38] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[40] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[73] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[74] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[75] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[80] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[82] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[112] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[113] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[114] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     else if(first_digit==9){
    leds[34] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[35] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[36] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[38] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[40] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[73] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[74] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[75] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[80] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[82] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[112] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[113] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[114] = CRGB(red_intensity,green_intensity,blue_intensity);
    }
  
  
  }




  void seconddigit(int second_digit){
    
 if(second_digit==0){
    leds[30] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[31] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[32] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[42] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[44] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[69] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[70] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[71] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[84] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[86] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[108] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[109] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[110] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

   else if(second_digit==1){
    leds[31] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[43] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[44] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[70] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[85] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[108] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[109] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[110] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

    else if(second_digit==2){
    leds[30] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[31] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[32] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[42] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[44] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[69] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[70] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[71] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[84] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[86] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[108] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[109] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[110] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

    else if(second_digit==3){
    leds[30] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[31] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[32] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[42] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[44] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[69] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[70] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[71] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[84] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[86] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[108] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[109] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[110] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

    else if(second_digit==4){
    leds[30] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[31] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[32] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[42] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[44] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[69] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[70] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[71] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[84] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[86] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[108] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[109] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[110] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

    else if(second_digit==5){
    leds[30] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[31] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[32] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[42] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[44] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[69] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[70] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[71] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[84] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[86] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[108] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[109] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[110] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

    else if(second_digit==6){
    leds[30] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[31] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[32] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[42] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[44] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[69] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[70] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[71] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[84] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[86] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[108] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[109] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[110] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

    else if(second_digit==7){
    leds[30] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[31] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[32] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[42] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[44] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[69] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[70] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[71] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[84] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[86] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[108] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[109] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[110] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

    else if(second_digit==8){
    leds[30] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[31] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[32] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[42] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[44] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[69] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[70] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[71] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[84] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[86] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[108] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[109] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[110] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

    else if(second_digit==9){
    leds[30] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[31] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[32] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[42] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[44] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[69] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[70] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[71] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[84] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[86] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[108] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[109] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[110] = CRGB(red_intensity,green_intensity,blue_intensity);
    }
    }


 void thirddigit(int third_digit){
    if(third_digit==0){
    leds[24] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[25] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[26] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[48] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[50] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[63] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[64] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[65] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[90] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[92] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[102] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[103] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[104] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     if(third_digit==1){
    leds[25] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[49] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[50] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[64] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[91] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[102] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[103] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[104] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     if(third_digit==2){
    leds[24] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[25] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[26] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[48] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[50] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[63] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[64] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[65] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[90] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[92] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[102] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[103] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[104] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     if(third_digit==3){
    leds[24] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[25] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[26] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[48] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[50] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[63] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[64] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[65] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[90] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[92] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[102] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[103] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[104] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     if(third_digit==4){
    leds[24] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[25] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[26] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[48] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[50] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[63] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[64] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[65] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[90] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[92] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[102] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[103] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[104] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     if(third_digit==5){
    leds[24] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[25] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[26] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[48] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[50] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[63] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[64] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[65] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[90] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[92] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[102] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[103] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[104] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     if(third_digit==6){
    leds[24] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[25] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[26] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[48] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[50] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[63] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[64] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[65] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[90] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[92] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[102] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[103] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[104] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     if(third_digit==7){
    leds[24] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[25] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[26] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[48] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[50] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[63] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[64] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[65] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[90] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[92] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[102] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[103] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[104] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     if(third_digit==8){
    leds[24] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[25] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[26] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[48] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[50] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[63] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[64] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[65] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[90] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[92] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[102] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[103] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[104] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     if(third_digit==9){
    leds[24] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[25] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[26] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[48] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[50] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[63] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[64] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[65] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[90] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[92] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[102] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[103] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[104] = CRGB(red_intensity,green_intensity,blue_intensity);
    }
  
 }


 void fourthdigit(int fourth_digit){
    if(fourth_digit==0){
    leds[20] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[21] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[22] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[52] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[54] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[59] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[60] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[61] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[94] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[96] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[98] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[99] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[100] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

    else if(fourth_digit==1){
    leds[21] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[53] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[54] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[60] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[95] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[98] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[99] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[100] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     else if(fourth_digit==2){
    leds[20] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[21] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[22] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[52] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[54] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[59] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[60] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[61] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[94] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[96] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[98] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[99] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[100] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     else if(fourth_digit==3){
    leds[20] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[21] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[22] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[52] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[54] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[59] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[60] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[61] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[94] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[96] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[98] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[99] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[100] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     else if(fourth_digit==4){
    leds[20] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[21] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[22] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[52] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[54] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[59] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[60] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[61] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[94] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[96] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[98] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[99] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[100] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     else if(fourth_digit==5){
    leds[20] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[21] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[22] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[52] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[54] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[59] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[60] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[61] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[94] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[96] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[98] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[99] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[100] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     else if(fourth_digit==6){
    leds[20] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[21] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[22] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[52] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[54] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[59] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[60] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[61] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[94] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[96] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[98] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[99] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[100] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     else if(fourth_digit==7){
    leds[20] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[21] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[22] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[52] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[54] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[59] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[60] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[61] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[94] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[96] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[98] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[99] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[100] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     else if(fourth_digit==8){
    leds[20] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[21] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[22] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[52] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[54] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[59] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[60] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[61] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[94] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[96] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[98] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[99] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[100] = CRGB(red_intensity,green_intensity,blue_intensity);
    }

     else if(fourth_digit==9){
    leds[20] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[21] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[22] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[52] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[54] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[59] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[60] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[61] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[94] = CRGB(red_intensity,green_intensity,blue_intensity);
//    leds[96] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[98] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[99] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[100] = CRGB(red_intensity,green_intensity,blue_intensity);
    }


 }




 void colon(int colon_state){
  if(colon_state==1){
    leds[46] = CRGB(red_intensity,green_intensity,blue_intensity);
    leds[88] = CRGB(red_intensity,green_intensity,blue_intensity);
    }
  
  }

void cleardisplay(){
  //This for loop is used to clear the display(with which we can draw on the display once again) 
  for(int i=0;i<135;i++)
   {
    leds[i]=CRGB(0,0,0);
   }
   }
